define('feature/pull-request/pull-request-diff', [
    'model/commit-range',
    'feature/changeset/tree-and-diff-view',
    'feature/pull-request/pull-request-history',
    'exports'
], function(
    CommitRange,
    treeAndDiffView,
    pullRequestHistory,
    exports
) {
        exports.init = function(pullRequest, maxChanges) {
            treeAndDiffView.init(new CommitRange({ pullRequest : pullRequest }), {
                commentMode : treeAndDiffView.commentMode.CREATE_NEW,
                maxChanges : maxChanges
            });
            pullRequestHistory.init();
        };
        exports.reset = function() {
            pullRequestHistory.reset();
            return treeAndDiffView.reset();
        };
    });