define('layout/branch',
    ['aui', 'eve', 'model/revision-reference', 'widget/branch-selector-dialog', 'exports'],
    function(AJS, eve, RevisionReference, BranchSelectorDialog, exports) {

        exports.onReady = function(atRevision,
                                   branchSelectorButtonSelector) {

            var currentRevisionRef = new RevisionReference(atRevision),
                branchSelectorDialog = new BranchSelectorDialog(branchSelectorButtonSelector, "branch-selector");


            /* Cascade changes upward */
            eve.on('stash.widget.branchselector.revisionRefChanged', function(revisionReference) {
                currentRevisionRef = revisionReference;
                if (this === branchSelectorDialog.branchSelector) {
                    eve('stash.layout.branch.revisionRefChanged', this, revisionReference);
                }
            });

            /* React to page changes */
            eve.on('stash.page.*.revisionRefChanged', function(revisionReference) {
                currentRevisionRef = revisionReference;
                branchSelectorDialog.updateSelectedRevisionReference(revisionReference);
            });

            eve.on('stash.widget.keyboard-shortcuts.register-contexts', function(keyboardShortcuts) {
                keyboardShortcuts.enableContext('branch');
            });
        };
    });
