define('page/admin/groupsList',
    ['exports', 'widget/pager', 'widget/pager-filter', 'widget/delete-dialog'],
    function (exports, Pager, PagerFilter, deleteDialog) {

    exports.onReady = function (tableId, deleteLinks) {

        // paging and AJAX rendering of the table
        var templatesByTarget = {};
        templatesByTarget[tableId] = function (page) {
            return stash.admin.groups.grouptable({
                groups: page,
                filtered : !!page.filter
            });
        };
        Pager.onReady(templatesByTarget, {
            usePushState: false
        });

        // confirm dialog to delete groups
        deleteDialog.bind(deleteLinks,
            stash_i18n("stash.web.groups.delete", "Delete group"),
            stash_i18n('stash.web.groups.delete.success', 'The group {0} was successfully deleted.'),
            stash_i18n('stash.web.groups.delete.fail', 'The group could not be deleted.'),
            function() {
                return PagerFilter.reload();
            });
    };
});
