define("page/admin/mailServer",
       ['exports', 'jquery', 'util/ajax', 'util/error', 'widget/confirm-dialog'], function(exports, $, ajax, errorUtil, ConfirmDialog) {

    exports.onReady = function(deleteButtonSelector, testButtonSelector) {

        // bind the 'Test' button to send a test email with the current config
        $(testButtonSelector).click(function() {
            var $this = $(this),
                $spinner = $("<div class='spinner'></div>");

            $this.nextAll().remove();
            $this.after($spinner);
            $spinner.spin();
        });

        // bind the delete button
        var $panelContent =
            $("<p>").text(stash_i18n('stash.web.mailserver.delete.confirm', 'Are you sure that you want to remove the mail server configuration?'));

        var confirmDialog = new ConfirmDialog({
            id:"delete-mail-sever-config-dialog",
            titleText: stash_i18n('stash.web.mailserver.delete.config', 'Delete the mail server configuration'),
            titleClass: 'warning-header',
            panelContent: $panelContent,
            submitText: stash_i18n('stash.web.button.delete', 'Delete')
        }, { type: 'DELETE' });

        confirmDialog.attachTo(deleteButtonSelector);

        confirmDialog.addConfirmListener(function (promise) {
            promise.done(function (data) {
                window.location.search = '?deleted=true';
            });
        });

    };
});