define('page/pull-requests-list',
    ['jquery', 'aui', 'eve', 'memoir', 'util/navbuilder', 'util/ajax', 'feature/pull-request/pull-request-table', 'widget/avatar-list', 'exports'],
    function ($, AJS, eve, memoir, navBuilder, ajax, PullRequestsTable, AvatarList, exports) {
        var pullRequestTable;

        function getPullRequestsUrlBuilder(state) {
            return navBuilder.rest().currentRepo().allPullRequests().withParams({ state: state });
        }

        function bindKeyboardShortcuts() {
            pullRequestTable.initShortcuts();

            eve.on('stash.widget.keyboard-shortcuts.register-contexts', function (keyboardShortcuts) {
                keyboardShortcuts.enableContext('pull-request-list');
            });

            eve.on('stash.keyboard.shortcuts.requestMoveToNextHandler', pullRequestTable.bindMoveToNextHandler);
            eve.on('stash.keyboard.shortcuts.requestMoveToPreviousHandler', pullRequestTable.bindMoveToPreviousHandler);
            eve.on('stash.keyboard.shortcuts.requestOpenItemHandler', pullRequestTable.bindOpenItemHandler);
            eve.on('stash.keyboard.shortcuts.pullrequest.requestHighlightAssignedHandler', pullRequestTable.bindHighlightAssignedHandler);
        }

        exports.onReady = function (state, order) {
            pullRequestTable = new PullRequestsTable(state, order, getPullRequestsUrlBuilder);
            pullRequestTable.init();
            AvatarList.init();

            bindKeyboardShortcuts();
        };
    });
