define('widget/breadcrumbs', ['eve', 'jquery', 'memoir', 'util/event', 'util/navbuilder', 'model/page-state'],
    function(eve, $, memoir, eventUtil, navBuilder, pageState) {

    function Breadcrumbs(containerSelector) {
        this.$container = $(containerSelector);
        if (memoir.nativeSupport()) {
            var self = this;
            this.$container.on('click', 'a', function(e) {
                if (eventUtil.openInSameTab(e)) {
                    eve('stash.widget.breadcrumbs.urlChanged', self, $(this).attr("href"));
                    e.preventDefault();
                }
            });
        }
    }

    var browseNavBuilder = navBuilder.currentRepo().browse(),
        browsePath = function(pathComponents, revisionReference) {
            if (!revisionReference.isDefault()) {
                return browseNavBuilder.path(pathComponents).at(revisionReference.getId()).build();
            } else {
                return browseNavBuilder.path(pathComponents).build();
            }
        };

    function createBreadcrumbData(revisionReference, pathComponents) {
        var pathSeed = [],
            breadcrumbParts = _.map(pathComponents, function (part) {
                pathSeed = pathSeed.slice(0); //shallow copy
                pathSeed.push(part);
                return {
                    text: part,
                    url: browsePath(pathSeed, revisionReference)
                };
            });

        //prepend repository link
        breadcrumbParts.unshift({
            text: pageState.getRepository().name,
            url: browsePath([], revisionReference)
        });

        return breadcrumbParts;
    }
    
    Breadcrumbs.prototype.update = function(revisionReference, path) {
        this.$container.empty().append(
            stash.widget.breadcrumbs.crumbs({
                'pathComponents': createBreadcrumbData(revisionReference, path.getComponents())
            }));
    };

    return Breadcrumbs;
});
