define('widget/merge-help', ['jquery', 'eve'],
    function($, eve) {

        var dialog;

        function createMergeHelpDialog(pullRequest, conflicted, vetoes) {
            var dialog = new AJS.Dialog({
                width:600,
                height:480,
                id:"merge-help-dialog",
                closeOnOutsideClick:true
            }).addHeader(stash_i18n("stash.web.pull-request.merge.help.header", "Issues Merging the Pull Request"));

            dialog.addPanel('',
                stash.widget.pullRequest.mergeHelp({
                    pullRequestId: pullRequest.getId(),
                    sourceBranch: pullRequest.getFromRef().getDisplayId(),
                    targetBranch: pullRequest.getToRef().getDisplayId(),
                    conflicted: conflicted,
                    vetoes: vetoes
                }));
            dialog.addCancel(stash_i18n('stash.web.button.close', 'Close'), _.bind(dialog.hide, dialog));

            return dialog;
        }

        function showMergeHelpDialog() {
            if (dialog) {
                dialog.show();
                dialog.updateHeight();
            }
        }

        var cantMergeHandler = function(pullRequest, conflicted, vetoes) {
            if (dialog) {
                dialog.remove();
            }
            dialog = createMergeHelpDialog(pullRequest, conflicted, vetoes);
        };

        return {
            init : function() {
                eve.on('stash.pull-request.cant.merge', cantMergeHandler);
                eve.on('stash.pull-request.show.cant.merge.help', showMergeHelpDialog);

            },
            reset : function() {
                eve.off('stash.pull-request.cant.merge', cantMergeHandler);
                eve.off('stash.pull-request.show.cant.merge.help', showMergeHelpDialog);
                if (dialog) {
                    dialog.remove();
                    dialog = null;
                }
            }
        };
});
