define("feature/filebrowser/file-finder",["jquery","underscore","eve","util/ajax","util/event","util/error","util/navbuilder","util/regexp","model/path","widget/keyboard-controller","widget/paged-scrollable","exports"],function(D,R,P,L,F,H,I,T,O,J,E,S){var G=J.ListKeyboardController;function N(U){var V=I.rest().currentRepo().files().all().at(U.getId());return V.build()}function C(W,U){var V=I.currentRepo().browse().path(W);if(!U.isDefault()){V=V.at(U.getDisplayId())}return V.build()}function B(U){return(U!=U.toUpperCase())?"["+T.escape(U.toUpperCase()+U)+"]":T.escape(U)}function A(U){return U.replace(/(^\s*)|(\s*$)/gi,"").replace(/[ ]{2,}/gi," ")}function K(V){if(V){var W="",X=A(V).split(/\*|\s|(?=[A-Z0-9]|\/|\.|-|_)/g);X=R.filter(X,function(Z){return Z.length!==0});var Y=X.length;if(Y){W+="("+R.map(X[0].split(""),B).join("")+")";for(var U=1;U<Y;U++){W+=".*?("+R.map(X[U].split(""),B).join("")+")"}return new RegExp("("+W+")","g")}}else{return null}}function Q(V,U){var W=this;this._isLoaded=false;this.fileTableSelector=V;this.currentRevisionRef=U;this.$textInput=D("input.filter-files");this.$finderTip=D("#file-finder-tip");this.$spinner=D("<div class='spinner'/>").hide().insertAfter(this.fileTableSelector);P.on("stash.page.filebrowser.revisionRefChanged",function(X){W.currentRevisionRef=X;W.files=undefined})}Q.prototype.tips=[stash_i18n("stash.web.filefinder.tip.1","Filter by directory path e.g. ''<strong>/ssh pom.xml</strong>'' to search for ''src<strong>/ssh/pom.xml</strong>''."),stash_i18n("stash.web.filefinder.tip.2","Use camelCasing e.g. ''<strong>ProjME</strong>'' to search for ''<strong>ProjectModifiedE</strong>vent.java''."),stash_i18n("stash.web.filefinder.tip.3","Filter by extension type e.g. ''<strong>/repo .js</strong>'' to search for all ''<strong>.js</strong>'' files in the ''<strong>/repo</strong>'' directory."),stash_i18n("stash.web.filefinder.tip.4","Separate your search with spaces e.g. ''<strong>/ssh pom.xml</strong>'' to search for ''src<strong>/ssh/pom.xml</strong>''."),stash_i18n("stash.web.filefinder.tip.5","Use ↑ and ↓ arrow keys to navigate and ''<strong>return</strong>'' to view the file.")];Q.prototype._bindKeyboardNavigation=function(){this._filesKeyboardController=new G(this.$textInput,D(this.fileTableSelector),{wrapAround:false,focusedClass:"focused-file",itemSelector:"tr.file-row",onSelect:function(U){window.location.href=U.find("a").attr("href")},requestMore:function(){var U=D.Deferred();window.scrollTo(0,document.documentElement.scrollHeight);setTimeout(function(){U.resolve()});return U}})};Q.prototype._showSpinner=function(){D(".filebrowser-banner").empty();D(this.fileTableSelector).empty();this.$spinner.show().spin("large")};Q.prototype._hideSpinner=function(){this.$spinner.spinStop().hide()};Q.prototype.isLoaded=function(){return this._isLoaded};Q.prototype.unloadFinder=function(){D(".breadcrumbs").removeClass("file-finder-mode");this.$textInput.blur().hide().val("");this.$finderTip.hide();this._isLoaded=false;this._filesKeyboardController.destroy();this.tableView.reset()};Q.prototype.loadFinder=function(){D(".filebrowser-banner").empty();D(".breadcrumbs").addClass("file-finder-mode");this.$textInput.focus();if(!this._isLoaded){this.requestFiles();this._isLoaded=true}};Q.prototype.requestFiles=function(){var U=this;this._showSpinner();if(this.files){this.onFilesLoaded();this._hideSpinner()}else{L.rest({url:N(U.currentRevisionRef)}).done(function(X){var W=X.values;U.files=[];for(var V=0;V<W.length;V++){U.files.push({name:W[V]})}U.onFilesLoaded()}).always(function(){U._hideSpinner()})}};Q.prototype.onFilesLoaded=function(){var V=this;this.$textInput.fadeIn();var U=this.tips[Math.floor(Math.random()*this.tips.length)];this.$finderTip.html(stash_i18n("stash.web.filefinder.tip.label","Tip: ")+U).fadeIn();this.showFiles();this._bindKeyboardNavigation();this._filesKeyboardController.moveToNext();var Y=this.$textInput,W=Y.val();function X(Z){V.showFiles(Z);V._filesKeyboardController.setListElement(D(V.fileTableSelector));V._filesKeyboardController.moveToNext()}this.$textInput.unbind("keyup").on("keyup",function(Z){if(Z.keyCode==27){P("stash.feature.filetable.hideFind",V)}}).on("keyup",R.debounce(function(Z){if(Z.keyCode!=27&&W!==(W=Y.val())){X(D(this).val())}},200)).focus();if(W){X(W)}};Q.prototype.showFiles=function(U){this.filteredFiles=this.files;var Y=K(U);if(this.tableView){this.tableView.reset()}if(Y&&this.files.length>0){this.filteredFiles=R.filter(this.files,function(Z){Y.lastIndex=0;return Y.test(Z.name)});Y.lastIndex=0;if(!D.browser.msie||parseInt(D.browser.version,10)>=9){var X=new RegExp(Y.source+"(?!.*/)");var V=function(Z){if(Z.exactMatches){return Z.exactMatches}return(Z.exactMatches=(Z.name.indexOf(U)>=0))};var W=function(Z){if(Z.matches){return Z.matches}return(Z.matches=X.test(Z.name))};this.filteredFiles.sort(function(Z,e){var c=V(Z),d=V(e);if(c!=d){return c?-1:1}var b=W(Z),a=W(e);if(b==a){return Z.name.localeCompare(e.name)}return b?-1:1})}}else{R.forEach(this.files,function(Z){Z.highlightedName=null;Z.matches=null;Z.exactMatches=null})}this._makeFileFinderView(Y)};Q.prototype._makeFileFinderView=function(U){this.tableView=new M(this.filteredFiles,U,this.fileTableSelector,this.currentRevisionRef);this.tableView.init()};function M(X,Y,W,U){var V=this;E.call(this,null,{pageSize:50});this.pattern=Y;this.fileTableSelector=W;this.filteredFiles=X;this.currentRevisionRef=U}D.extend(M.prototype,E.prototype);M.prototype.requestData=function(X,U){var V=this,W=this.filteredFiles.slice(X,X+U);R.forEach(W,function(Y){if(!Y.url){Y.url=C(new O(Y.name),V.currentRevisionRef)}Y.highlightedName=AJS.escapeHtml(Y.name).replace(V.pattern,"<strong>$1</strong>")});return D.Deferred().resolve({values:W,size:W.length,isLastPage:(X+2*U)>=this.filteredFiles.length})};M.prototype.attachNewContent=function(Z,Y){var X=D(this.fileTableSelector);if(Y==="html"){var W=D(stash.feature.filefinder.fileFinderTable({files:Z.values}));X.replaceWith(W)}else{var V=Y==="append",U=D(X,"table > tbody");R.each(Z.values,function(b){var a=D(stash.feature.filefinder.fileFinderRow(D.extend({},b,{name:b.highlightedName})));if(V){U.append(a)}else{U.prepend(a)}})}};S.FileFinder=Q});