define("widget/permission-table",["jquery","underscore","aui","model/page-state","util/ajax","util/navbuilder","util/error","util/warn-before-unload","exports"],function(E,K,J,I,H,A,B,D,C){function G(Q,M){function P(R){return H.rest({url:Q[M+"s"]().none().build(),type:"GET",data:R})}function L(R){return H.rest({url:Q[M+"s"]().build(),type:"GET",data:R})}function O(R,S){return H.rest({url:Q[M+"s"]().withParams({permission:R,name:S}).build(),type:"PUT",statusCode:{"400":function(){return false},"403":function(){return false},"404":function(){return false},"409":function(){return false}}})}function N(R){return H.rest({url:Q[M+"s"]().withParams({name:R}).build(),type:"DELETE",statusCode:{"400":function(){return false},"403":function(){return false},"404":function(){return false},"409":function(){return false}}})}return{getMembers:L,getNonMembers:P,setPermission:O,removePermissions:N}}function F(M,O,L,N,Q,P){this._entityType=N;if(this._entityType==="user"){this._text=F.userText;this._rowTemplate=stash.widget.userPermissionRow;this._isEntityCurrentUser=function(R){return I.getCurrentUser()&&R.name===I.getCurrentUser().name}}else{this._text=F.groupText;this._rowTemplate=stash.widget.groupPermissionRow;this._isEntityCurrentUser=function(){return false}}this._dataSource=G(O,this._entityType);this._permissions=K.pluck(L,"name");this._initialPermission=this._permissions[this._permissions.length-1];this._permissionNames=K.pluck(L,"i18nName");this._currentUserHighestPerm=Q;this._pageSize=50;this._addedEntities=[];this.opts=P||{};this._wireComponents(M);this._initAddButton();this._initRows();this._initLoadMoreButton();this.refresh()}F.text={addModal:{buttonDoingText:stash_i18n("stash.web.permission.table.filter.adding","Adding..."),buttonDoneText:stash_i18n("stash.web.permission.table.filter.added","Added"),closeButtonText:stash_i18n("stash.web.permission.table.filter.done","Done"),addItemUnknownError:stash_i18n("stash.web.groups.picker.unexpected.error","The element could not be added. Please consult the logs for more information.")},entityList:{buttonLoadMoreText:stash_i18n("stash.picker.load.more","Load more")},pendingModification:stash_i18n("stash.web.pending.request","You have made permission changes that have not yet reached Stash. If you leave this page, those changes will be lost."),cantGrantHigherPerms:function(L){return stash_i18n("stash.web.permission.table.cantgranthigher.tooltip","You cannot grant the {0} permission",L)},inheritedPerm:stash_i18n("stash.web.permission.table.inheritedperm.tooltip","This permission is inherited from a higher permission")};F.userText=E.extend(true,{inactiveEntity:function(L){return stash_i18n("stash.web.permission.table.inactive.user","{0} is deleted or marked as inactive in a remote directory",L)},addModal:{title:stash_i18n("stash.web.permission.table.available.users","Available Users"),filterPlaceholder:stash_i18n("stash.web.permission.table.users.search.placeholder","Search users"),buttonText:stash_i18n("stash.web.permission.table.add.user","Add User"),noItemsText:stash_i18n("stash.web.permission.table.no.users","No users."),loadingItemsText:stash_i18n("stash.web.permission.table.loading.users","Loading users...")},cantRevokeHigherPerms:function(L){return stash_i18n("stash.web.permission.table.cantrevokehigheruser.tooltip","You cannot change permissions for a {0} ",L)},cantGrantSelfHigherPerms:function(L){return stash_i18n("stash.web.permission.table.cantgrantselfhigher.tooltip","You cannot grant yourself the {0} permission",L)},implicitPerm:stash_i18n("stash.web.permission.table.basePerm.tooltip","To remove this permission, click the X to the right to remove the entire row."),noMoreItemsText:stash_i18n("stash.web.permission.table.users.picker.none.added","All users already have permissions set.")},F.text);F.groupText=E.extend(true,{inactiveEntity:function(L){return stash_i18n("stash.web.permission.table.invisible.group","{0} is deleted",L)},addModal:{title:stash_i18n("stash.web.permission.table.available.groups","Available Groups"),filterPlaceholder:stash_i18n("stash.web.permission.table.group.search.placeholder","Search groups"),buttonText:stash_i18n("stash.web.permission.table.add.group","Add Group"),noItemsText:stash_i18n("stash.web.permission.table.no.groups","No groups."),loadingItemsText:stash_i18n("stash.web.permission.table.loading.groups","Loading groups...")},cantRevokeHigherPerms:function(L){return stash_i18n("stash.web.permission.table.cantrevokehighergroup.tooltip","You cannot change permissions for a {0} group",L)},implicitPerm:stash_i18n("stash.web.permission.table.basePerm.tooltip","To remove this permission remove the group row"),noMoreItemsText:stash_i18n("stash.web.permission.table.groups.picker.none.added","All groups already have permissions set.")},F.text);F.prototype._wireComponents=function(L){this._$container=E(L);this._$addButton=this._$container.find(".add-button");this._$tbody=this._$container.find("tbody");this._$noResults=this._$container.find(".no-results-row");this._$loadMore=this._$container.find(".load-more");this._$spinner=E(this._$loadMore).parent().append('<div class="permissions-spinner" />').find(".permissions-spinner")};F.prototype._getModalItem=function(L){return{content:E(stash.widget.permissionModalItem({entity:L,isUser:this._entityType==="user",inactiveText:this._text.inactiveEntity(L.name)})),id:L.name}};F.prototype._initAddButton=function(){var M=this;var L=[];this._$addButton.bindModalFilteredPicker(E.extend({buttonDoneClass:"green",panelClass:this._entityType+"-dialog-panel",pageSize:25,retrieveItems:function(O,P,N,Q){M._dataSource.getNonMembers({filter:O,start:P,limit:N,avatarSize:stash.widget.avatarSizeInPx({size:"xsmall"})}).done(function(S){L=L.concat(S.values);var R=K.map(S.values,function(T){return M._getModalItem(T)});Q(R,!S.isLastPage,S.nextPageStart)})},buttonPressed:function(P,N,O){M._dataSource.setPermission(M._initialPermission,P).done(function(){var Q=K.find(L,function(R){return R.name===P});if(Q){M._addedEntities.push(Q)}if(N){N()}}).fail(function(S,T,R,Q){if(Q&&Q.errors){O(Q.errors)}else{O([{message:M._text.addModal.addItemUnknownError}])}})},onClose:function(){L=[];M.refresh()},isDisabled:function(){return M._$addButton.hasClass("disabled")},noMoreItemsText:this._text.noMoreItemsText,noItemsText:this._text.noItemsText},this._text.addModal))};F.prototype._updateErrors=function(L,N){var M=L.closest("tr").find(".permissions-item").parent();M.closest("tbody").find(".error-message").remove();return N.fail(function(Q,R,P,O){if(O&&O.errors){E.each(O.errors,function(S){M.append(E('<span class="error-message" />').text(O.errors[S].message))})}})};F.prototype._spinWhilePending=function(L,N){if(N&&N.state()==="pending"){L.closest("tr").find(":checkbox").prop("disabled",true);var M=E('<div class="spinner" />');M.insertAfter(L);L.addClass("hidden");M.spin("small");N.always(function(){L.removeClass("hidden");M.spinStop().remove()})}};F.prototype._getAllCheckboxes=function(L){return L.parent().parent().find(":checkbox")};F.prototype._getCheckboxStates=function(L){return E.map(L,function(M){return{checked:E(M).prop("checked"),disabled:E(M).prop("disabled")}})};F.prototype._restoreCheckboxStates=function(M,L){E.each(L,function(N,P){var O=E(M.get(N));O.prop("checked",P.checked).prop("disabled",P.disabled).toggleClass("disabled",P.disabled)})};F.prototype._setChecked=function(O,N,L){this._restoreCheckboxStates(this._getAllCheckboxes(O),L);N.prop("checked",false).prop("title","");var P=O.parent().nextAll().children(":checkbox").prop("checked",true).prop("disabled",true).addClass("disabled").prop("title",this._text.inheritedPerm);O.prop("title",P.length?"":this._text.implicitPerm);O.prop("checked",true).prop("disabled",!P.length).toggleClass("disabled",!P.length);var M=O.closest("[data-entity-id]").attr("data-entity-id");K.each(this._addedEntities,function(Q){if(Q.name===M){Q.permission=O.val()}})};F.prototype._initRows=function(){var L=this;this._$tbody.on("change",":checkbox",function(){var U=E(this);var O=U.parent();var N=O.next();var R=O.parent().attr("data-entity-id");var T,P;var Q,W;if(this.checked){while(N.length&&!N.children(":checked").length){N=N.next()}T=N.children(":checkbox");P=U;Q=T.prop("value");W=this.value}else{T=U;P=N.children(":checkbox");Q=this.value;W=P.prop("value")}var M=[];if(W){M.push(L._dataSource.setPermission(W,R))}var S=L._getCheckboxStates(L._getAllCheckboxes(P));var V=E.when.apply(E,M);L._spinWhilePending(U,V);L._updateErrors(U,V);V.done(function(){L._setChecked(P,T,S)}).fail(function(Z,a,Y,X){L._setChecked(T,P,S)});D(V,L._text.pendingModification)}).on("click",".delete-button",function(S){var R=E(this),O=R.parents("tr").first(),N=O.attr("data-entity-id"),Q=O.find(":checkbox"),M=L._getCheckboxStates(Q);var P=L._dataSource.removePermissions(N);L._spinWhilePending(R,P);L._updateErrors(R,P);P.done(function(){L._numLoaded--;L._addedEntities=K.filter(L._addedEntities,function(U){if(U.name===N&&!U.loaded){L._numLoaded++}return U.name!==N});if(!O.siblings().length&&!L._$loadMore.is(":visible")){var T=L._$noResults.find("div");T.css("opacity",0);L._$noResults.show();T.animate({opacity:1},500)}O.remove()}).fail(function(){L._restoreCheckboxStates(Q,M)});D(P,L._text.pendingModification);S.preventDefault();return false})};F.prototype._initLoadMoreButton=function(M){var L=this;this._$loadMore.click(function(N){L._loadItems();N.preventDefault()})};F.prototype._renderRow=function(L,Q,S,N){var T=this;var O=K.isUndefined(Q)?T._permissions.length-1:K.indexOf(this._permissions,Q);var R=K.indexOf(this._permissions,S);var M=O<R;var P=T._permissionNames[O];return this._rowTemplate({entity:L,entityPermissions:K.map(this._permissions,function(W,V,a){var Z=T._permissionNames[V];var Y=W===Q;var X=V<R;var U=K.any(a.slice(0,V),function(b){return b===Q});return{name:W,granted:Y,inherited:U,privileged:X,tooltip:(function(){if(M){return""}else{if(X&&!Y){if(T._isEntityCurrentUser(L)){return T._text.cantGrantSelfHigherPerms(Z)}else{return T._text.cantGrantHigherPerms(Z)}}else{if(U){return T._text.inheritedPerm}else{if(V==T._permissions.length-1){return T._text.implicitPerm}else{return""}}}}}())}}),tooltip:M?T._text.cantRevokeHigherPerms(P):"",showAddedLozenge:N,showRemovePermsButton:N||(O>=R),linkToEntities:I.getCurrentUser().isAdmin})};F.prototype._loadItems=function(){var L=this;this._$spinner.spin("small");if(!this._numLoaded){L._$tbody.empty();L._$noResults.hide()}if(!this._numLoaded&&this._addedEntities.length){L._$tbody.append(K.chain(this._addedEntities).sortBy(function(M){return M.name}).reduce(function(N,M){return N+L._renderRow(M,M.permission,L._currentUserHighestPerm,true)},"").value())}L._dataSource.getMembers({start:L._numLoaded,limit:L._pageSize,avatarSize:stash.widget.avatarSizeInPx({size:"xsmall"})}).done(function(N){if(L.opts.preProcessMembers){N=L.opts.preProcessMembers(N,L._entityType)}L._$spinner.spinStop();L._$loadMore.toggleClass("hidden disabled",N.isLastPage);if(N.values.length){L._$noResults.hide()}else{if(!N.start&&!L._addedEntities.length){L._$noResults.show()}}L._numLoaded+=N.values.length;var O=K.invoke(K.pluck(L._addedEntities,"name"),"toLowerCase");var M=K.chain(N.values).filter(function(P){var Q=E.inArray(P[L._entityType].name.toLowerCase(),O);if(Q!==-1){L._addedEntities[Q].loaded=true}return Q===-1}).value();if(M.length){L._$tbody.append(K.reduce(M,function(P,Q){return P+L._renderRow(Q[L._entityType],Q.permission,L._currentUserHighestPerm)},""))}L._$noResults.find("div").show()})};F.prototype.refresh=function(L){if(L){this._addedEntities=[]}this._numLoaded=0;K.each(this._addedEntities,function(M){M.loaded=false});this._loadItems()};C.initialise=function(L,M,O,N){return K.map(["user","group"],function(P){return new F("#"+P+"-permissions-table",L,M,P,O,N)})}});